unit Ut_dialg;

interface

{ petites routines d'affichage }
{ nouvelles, prfrables }
procedure YesBox (const chaine : String) ;  { Oui }
procedure YesBox2 (const texte1, texte2 : String) ;
procedure StopBox (const chaine : String) ;{ stop & cancel }
procedure ExclamBox (const chaine : String) ;{ ! & cancel }
function yesNoBox (const question : string) : Word; { ? et OuiNon}

procedure RealBox (const commentaire : String; x : Extended);
procedure IntBox (const commentaire : String; x : LongInt);

{**********************************************************************}
implementation

uses Dialogs;

procedure YesBox (const chaine : String) ;
  begin
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;

procedure YesBox2 (const texte1, texte2 : String) ;
  var chaine : string ;
  begin
    chaine := texte1 + texte2 ;
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;

procedure StopBox (const chaine : String) ;
  begin
    MessageDlg (chaine, mtError, [mbCancel], 0);
  end ;

procedure ExclamBox (const chaine : String) ;
  begin
    MessageDlg (chaine, mtWarning, [mbCancel], 0);
  end ;

function YesNoBox (const question : string) : Word; { ? et OuiNon}
  begin
    Result := MessageDlg (question, mtConfirmation, [mbYes, mbNo],0);
  end ;


procedure RealBox (const commentaire : String; x : Extended);
  var chaine : String ;
  begin
    str(x, chaine);
    chaine := commentaire+chaine;
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;

procedure IntBox (const commentaire : String; x : LongInt);
  var chaine : String ;
  begin
    str(x, chaine);
    chaine := commentaire+chaine;
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;

end.
