unit Ut_list;

interface

  uses Classes, StdCtrls;

  procedure ElimineDuplicates
      ( UneListe : TStrings; Suspect : integer; CaseSensitive : Boolean);
  { limine tous les doubles de la liste; si besoin est, on n'limine
  que les doubles de Suspect (voire Suspect lui-mme);
  Suspect doit tre  - 1 pour que tous les doubles sautent ;
  ATTENTION : -  penser que les ns cont de 0  count-1 ;
              - au retri automaitique par Sorted (le dsactiver avant
              l'ajout de l'lment suspect)
  CaseSensitive indique si on doit se proccuper ou non de la distinction
  min-maj)}

  function AddListBoxEtElimineDuplicates
      ( UneListeBox : TListBox; chaine : string; CaseSensitive : Boolean)
       : integer;
    { idem : appelle la procdure prcdente en inhibant le tri un temps
      & renvoie la premire occurence de la chane}


  function CHercheInStrings (UneListe : TStrings; ch : string; CaseSensitive : Boolean) : integer;
  { recheche une chane prcise dans la liste
    donne la 1ere occurence, -1 si pas trouv }



implementation

uses SysUtils    ;


 procedure ElimineDuplicates
      (UneListe : TStrings; Suspect : integer; CaseSensitive : Boolean);
  var i,j,k : integer ;
      orig, autre : String ;
      semblables : Boolean ;
  begin

    if Suspect<0 then i:= 0  { toute la liste  }
                 else i:= Suspect ;

    repeat
      {pour chaque lment, parcourir toute la liste et flinguer les doubles}

      with UneListe do begin
        orig := UneListe.Strings[i] ;
        if not CaseSensitive then orig := Lowercase(orig) ;

        j:=0 ;
        repeat
          if j<>i then begin
            autre := UneListe.Strings[j] ;

            Semblables := False ;
            if not CaseSensitive then
              Semblables := (orig = LowerCase(autre))
            else
              Semblables := (orig = autre) ;

            if Semblables then begin
              UneListe.Delete (j) ;  { suppression du double }
              if j<i then i:=i-1 ;   { rsout le dcalage de i}
            end ;
          end ;

          Inc(j) ;
        until (j>UneListe.Count-1);
      end ;

      Inc (i) ;
    until (Suspect>=0) or (i>UneListe.Count-1);

  end ;

function AddListBoxEtElimineDuplicates
      ( UneListeBox : TListBox; chaine : string; CaseSensitive : Boolean )
       : integer ;
  var WasSorted : Boolean ;
  begin
    with UneListeBox do begin
      WasSorted := Sorted ;
      Sorted := False ;
      items.Add(chaine);
      ElimineDuplicates (Items, Items.Count-1, CaseSensitive) ;
      Sorted := WasSorted;
      Result := Items.IndexOf (chaine);
    end ;
  end ;

function ChercheInStrings (UneListe : TStrings; ch : string; CaseSensitive : Boolean) : integer;
 { mieux que IndexOf pour la CaseSensitivit }
  var i : integer ;
      res : integer ;
      sembl :  Boolean ;
  label 100 ;
  begin
   res := -1 ;
   if uneListe.Count=0 then goto 100 ;

   i:=0;
   if CaseSensitive then ch := LowerCase(ch);
   repeat
     if CaseSensitive then
       sembl := (ch = UneListe.Strings[i])
     else
       sembl := (ch = Lowercase(UneListe.Strings[i]));

     if sembl then res := i;

     Inc(i) ;
   until (i>UneListe.Count-1) or (res>0);

   100:
   Result := res ;

  end ;



end.
